* ----------------------------------------
*	XLSdemoscan
*	  XLS   
* ----------------------------------------

*  
#DEFINE	YES				.T.
#DEFINE	NO				.F.
#DEFINE	SCAN_END_SCAN	"@END_SCAN@"	&&    
#DEFINE	SCAN_END_ROW	"@END_ROW@"		&&    
#DEFINE	SCAN_MAX_ROWS	200				&&    
#DEFINE	SCAN_MAX_COLS	20				&&    

*    
SET TALK OFF
CLEAR
CLOSE ALL
CLEAR ALL
PRIVATE poScaner
LOCAL i

* 
poScaner = CREATEOBJECT( "scnDemoScaner" )
poScaner.MaxRows = SCAN_MAX_ROWS	&&      
poScaner.MaxCols = SCAN_MAX_COLS	&&      
poScaner.ScanStop = SCAN_END_SCAN	&&  -
poScaner.ScanEndRow = SCAN_END_ROW	&&   -  
poScaner.ScanShow = YES				&&    

IF NOT poScaner.Open( "Test.xls" )	THEN
*      :
* poScaner.FileName = "Test.xls"
* poScaner.Open()
	? "  "
	RETURN
ENDIF
*  
? " "
IF NOT poScaner.Scan() THEN
	? " "
	RETURN
ENDIF
? ""
*  
? " "
? " : " + poScaner.FileName
? "  : " + STR( poScaner.ScanPages, 2 )
FOR i = 1 TO poScaner.ScanPages
	? "-  " + STR( i, 2 )
	? "- -     : " + STR( poScaner.Results( i, 1 ), 3 )
	? "- -  : " + STR( poScaner.Results( i, 2 ), 3 )
	? "- -     : " + STR( poScaner.Results( i, 3 ), 3 )
	? "- -   : " + STR( poScaner.Results( i, 4 ), 3 )
NEXT
*  
poScaner.Close()			&&   ,   Excel (!!!)
							&&       Open() 
							&&      Excel- 
poScaner.Release()			&&  Excel  
CLOSE ALL
CLEAR ALL

* ----------------------------------------
*	 -  XLS 
* ----------------------------------------
DEFINE CLASS cstXLSscaner	AS Custom
	*  XLS 
	FileName = ""
	*   
	ScanPages = 0
	*  
	DIMENSION Results[1,4]
	*     
	MaxRows = 16384
	*     
	MaxCols = 128
	*   
	ScanStop = ""
	*   
	ScanEndRow = ""
	*   Excel   
	ScanShow = NO
	*    Excel
	protected oExcel
	oExcel = .NULL.
	
	* ----------------------------------------
	*	  
	* ----------------------------------------
	*	PARAMETERS:
	*		1. [tcFile] -   
	* ----------------------------------------
	*	RETURN Log
	* ----------------------------------------
	FUNCTION Open
	LPARAMETER tcFile
		*  
		IF PARAMETER() = 1 THEN
			IF TYPE( "tcFile" ) <> "C" THEN
				RETURN NO
			ELSE
				THIS.FileName = tcFile
			ENDIF
		ENDIF
		*  
		IF EMPTY( THIS.FileName ) ;
				OR NOT FILE( THIS.FileName ) ;
				OR UPPER( JUSTEXT( THIS.FileName ) ) <> "XLS" THEN
			RETURN NO
		ENDIF
		*  
		IF ISNULL( THIS.oExcel ) THEN
			THIS.oExcel = CREATEOBJECT( "Excel.Application" )
		ENDIF
		THIS.oExcel.Workbooks.Open( FULLPATH( THIS.FileName ) )
		RETURN TYPE( "THIS.oExcel.Workbooks(1).Name" ) = "C"
	ENDFUNC
	* ----------------------------------------
	*	  
	* ----------------------------------------
	*	RETURN Log
	* ----------------------------------------
	FUNCTION Close
		IF TYPE( "THIS.oExcel.Workbooks(1)" ) <> "O" THEN
			
			RETURN YES
		ENDIF
		THIS.oExcel.Workbooks(1).Close()
		RETURN TYPE( "THIS.oExcel.Workbooks(1)" ) <> "O"
	ENDFUNC
	* ----------------------------------------
	*	 
	* ----------------------------------------
	PROCEDURE Release
		IF NOT ISNULL( THIS.oExcel ) THEN
			THIS.Close()
			THIS.oExcel.Quit()
		ENDIF
		RELEASE THIS			
	ENDPROC
	* ----------------------------------------
	*	 
	* ----------------------------------------
	*	RETURN Log
	* ----------------------------------------
	*      ,
	*   ,    , ,
	*     Open() 
	*   
	* ----------------------------------------
	FUNCTION Scan
		IF TYPE( "THIS.oExcel.Workbooks(1).Sheets.Count" ) <> "N" THEN
			RETURN NO
		ENDIF
		LOCAL iSheet, iRow, iCol, liDynamicMaxCols, luValue, lcCode, loCell

		THIS.ScanPages = THIS.oExcel.Workbooks(1).WorkSheets.Count
		DIMENSION THIS.Results[ THIS.ScanPages, 4 ]
		STORE 0 TO THIS.Results
		THIS.oExcel.Visible = THIS.ScanShow
		
		FOR iSheet = 1 TO THIS.ScanPages
	        THIS.oExcel.Workbooks(1).Worksheets( iSheet ).Activate
			liDynamicMaxCols = THIS.MaxCols
	
			FOR iRow = 1 TO THIS.MaxRows
			
				FOR iCol = 1 TO liDynamicMaxCols
					THIS.oExcel.ActiveSheet.Cells( iRow , iCol ).Activate
					loCell = THIS.oExcel.ActiveCell
					IF TYPE( "loCell.Comment.Text" ) <> "C" THEN
						LOOP
					ENDIF
					lcCode = ALLTRIM( loCell.Comment.Text )
					*  -
					IF UPPER( lcCode ) = UPPER( THIS.ScanStop ) THEN
						EXIT
					ENDIF
					*   
					IF UPPER( lcCode ) = UPPER( THIS.ScanEndRow ) THEN
						liDynamicMaxCols = iCol
						EXIT
					ENDIF
					*   
					IF THIS.CheckValue( loCell.Value, lcCode ) THEN
						THIS.Results[ iSheet, 3 ] = THIS.Results[ iSheet, 3 ] + 1
					ELSE
						THIS.Results[ iSheet, 4 ] = THIS.Results[ iSheet, 4 ] + 1
					ENDIF
					THIS.Results[ iSheet, 2 ] = liDynamicMaxCols
				NEXT	&& iCol
				*  -
				IF UPPER( lcCode ) = UPPER( THIS.ScanStop ) THEN
					EXIT
				ENDIF
				THIS.Results[ iSheet, 1 ] = iRow

			NEXT	&& iRow

		NEXT	&& iSheet
		
		THIS.oExcel.Visible = NO
		RETURN YES
	ENDFUNC
	* ----------------------------------------
	*	    
	*	  
	* ----------------------------------------
	*	PARAMETERS:
	*		1. tuValue	-  
	*		2. tcCode	-  
	* ----------------------------------------
	*	RETURN Log
	* ----------------------------------------
	FUNCTION CheckValue
	LPARAMETERS tuValue, tcCode	
		RETURN YES
	ENDFUNC
ENDDEFINE

* ----------------------------------------
*	 -
* ----------------------------------------
DEFINE CLASS scnDemoScaner AS cstXLSscaner
	*  -  
	hidden DemoCodes[5]

	* ----------------------------------------
	*	Init
	* ----------------------------------------
	PROCEDURE Init
		THIS.DemoCodes[1] = "1000"
		THIS.DemoCodes[2] = "1001"
		THIS.DemoCodes[3] = "1002"
		THIS.DemoCodes[4] = "1003"
		THIS.DemoCodes[5] = "1004"
		
		RETURN DODEFAULT()
	ENDPROC
	
	* ----------------------------------------
	*  
	* ----------------------------------------
	*	PARAMETERS:
	*		1. tuValue	-  
	*		2. tcCode	-  
	* ----------------------------------------
	*	RETURN Log
	* ----------------------------------------
	FUNCTION CheckValue
	LPARAMETERS tuValue, tcCode	
		LOCAL i
		FOR i = 1 TO 5
			IF UPPER( tcCode ) == THIS.DemoCodes[i]
				? ": " + tcCode + "  : "
				?? tuValue
				RETURN YES
			ENDIF
		NEXT
		RETURN NO
	ENDFUNC
ENDDEFINE